<!DOCTYPE html>
<html lang="en">

<head>
	<meta charset="UTF-8">
	<title>JS Task</title>
	<link rel="stylesheet"
		href="https://fonts.googleapis.com/css?family=Raleway:200,400,400i,500,700,900&amp;display=swap" media="all">
	<style>
		/* Write the code here */
		body * {
			font-family: Raleway !important;
		}

		.yotpo-icon.yotpo-icon-write {
			display: none;
		}

		.yotpo .yotpo-icon-share::before,
		.yotpo .yotpo-icon-thumbs-up::before,
		.yotpo-icon-thumbs-down::before {
			content: none !important;

		}

		div.yotpo-default-button.yotpo-icon-btn.pull-right.yotpo-hidden-mobile.write-button.write-review-button,
		button.yotpo-default-button.write-review-button.write-first-review-button {
			padding: 15px 30px;
			font-weight: 600 !important;
			background-color: transparent !important;
			border: 3px solid #333333 !important;
			color: #333 !important;

		}

		input[type="button"].yotpo-default-button.primary-color-btn.yotpo-submit {
			background-color: #333333 !important;
			border: 3px solid #333333 !important;
			color: white !important;
			padding: 15px 30px;
			font-weight: bold !important;
		}

		input[type="button"].yotpo-default-button.primary-color-btn.yotpo-submit:hover {
			border: 3px solid #333333 !important;
			color: black !important;
			background-color: transparent !important;
			padding: 15px 30px;
			transition: 0.2s;
		}

		span.yotpo-icon-button-text {
			color: #333 !important;
			font-weight: bold !important;
		}

		.yotpo-default-button.yotpo-icon-btn.pull-right.yotpo-hidden-mobile.write-button.write-review-button:hover span,
		button.yotpo-default-button.write-review-button.write-first-review-button:hover {
			color: black !important;
			color: white !important;
			transition: 0.2s;
		}

		.yotpo-default-button.yotpo-icon-btn.pull-right.yotpo-hidden-mobile.write-button.write-review-button:hover,
		button.yotpo-default-button.write-review-button.write-first-review-button:hover {
			background-color: #333333 !important;
			border: 3px solid #333333 !important;
			color: white !important;
			transition: 0.2s;
		}

		div.yotpo-bottomline-box-1.yotpo-stars-and-sum-reviews span.yotpo-icon.yotpo-icon-empty-star.rating-star.pull-left::before {
			content: none !important;
		}

		span.yotpo-stars {
			padding-bottom: 0 !important;
		}

		div.yotpo-first-review-stars span.stars-wrapper>.yotpo-icon.yotpo-icon-star:before {
			content: none !important;
		}

		div.form-element.submit-button .yotpo-default-button.primary-color-btn.yotpo-submit {
			margin-top: 0 !important;
		}

		div.yotpo-footer.yotpo-animation-opacity.visible .socialize-wrapper.visible {
			display: flex !important;
			flex-direction: row-reverse;
			left: 400px;
		}

		div.form-element.submit-button {
			margin-top: 30px;
		}

		.yotpo span.yotpo-mandatory-mark {
			color: black !important;
		}

		.yotpo .write-review .connect-wrapper {
			padding-left: 0 !important;
		}

		.yotpo .error {
			border: 1px solid rgb(65 65 65 / 40%) !important;
		}

		.yotpo-nav-content span.yotpo-icon.yotpo-icon-empty-star::before,
		.yotpo-nav-content span.yotpo-icon.yotpo-icon-star::before {
			content: none;
		}

		#total-reviews-block {
			font-family: Raleway !important;
			float: left;
			margin-right: 150px;
			color: black;
			min-height: 51px;
			display: flex;
			flex-direction: column;
			padding-top: 5px;
		}

		#total-reviews-text {
			margin-top: 13px;
			font-size: 16px;

		}

		#total-reviews-number {
			font-weight: bold;
			font-size: 26px;
			color: #333333;
		}

		#average-raiting-count {
			display: inline-block;
			font-weight: bold;
			color: #333333;
			font-size: 26px;
		}
	</style>
</head>

<body>
	<ol>
		<li>
			Фонт должен быть Raleway у всех элементов
		</li>
		<li>
			Вид виджета без отзывов - <a href="https://take.ms/msErQ" target="_blank">https://take.ms/msErQ</a>
		</li>
		<li>
			Вид виджета с отзывами - <a href="https://take.ms/S5nNf" target="_blank">https://take.ms/S5nNf</a>, <a
				href="https://take.ms/tT7QE" target="_blank">https://take.ms/tT7QE</a>, <a href="https://take.ms/NjGbsf"
				target="_blank">https://take.ms/NjGbsf</a>
		</li>
		<li>
			Вид формы "Write a review" - <a href="https://take.ms/ij1q9" target="_blank">https://take.ms/ij1q9</a>, <a
				href="https://take.ms/ZDE1u" target="_blank">https://take.ms/ZDE1u</a>.
			<br>Buttons Hover: <a href="https://take.ms/uJ2sK" target="_blank">https://take.ms/uJ2sK</a>, <a
				href="https://take.ms/eQpdH" target="_blank">https://take.ms/eQpdH</a>
		</li>
	</ol>
	<div>
		<h3>Иконки</h3>
		<p>
			<svg id="svg-share-icon" xmlns="http://www.w3.org/2000/svg" width="14.95" height="13.635"
				viewBox="1535.594 327.683 14.95 13.635">
				<path
					d="m1550.543 334.495-6.212-6.812v4.064h-1.321a7.416 7.416 0 0 0-7.416 7.416v2.154l.586-.643a10.528 10.528 0 0 1 7.777-3.43h.374v4.064l6.212-6.813Zm0 0"
					fill="#707070" fill-rule="evenodd"></path>
			</svg>

			<svg id="thumbs-up-icon" xmlns="http://www.w3.org/2000/svg" width="17.478" height="14.092"
				viewBox="2452.571 306.454 17.478 14.092">
				<g>
					<g>
						<path
							d="M2454.134 308.99h2.16c.81 0 1.477.62 1.555 1.409v8.493l-.008-.004a1.566 1.566 0 0 1-1.546 1.331h-2.16a1.565 1.565 0 0 1-1.564-1.564v-8.1c0-.863.701-1.565 1.563-1.565Z"
							fill="#707070" fill-rule="evenodd"></path>
					</g>
					<g>
						<path
							d="M2458.778 310.034c.626-.21 1.834-.683 2.38-1.053l3.43-2.321c.546-.37 1.216-.227 1.488.317.272.545.13 1.39-.314 1.877l-1.636 1.776h4.722c.66-.004 1.2.518 1.2 1.179v.057c0 .66-.54 1.2-1.2 1.2.66 0 1.2.54 1.2 1.2v.093c0 .66-.54 1.2-1.2 1.2h-.867c.66 0 1.2.54 1.2 1.2v.093c0 .66-.54 1.2-1.2 1.2h-.99c.66 0 1.2.54 1.2 1.2v.094c0 .66-.54 1.2-1.2 1.2h-4.636c-.66 0-1.683-.242-2.273-.537l-1.304-.652v-9.323Z"
							fill="#707070" fill-rule="evenodd"></path>
					</g>
				</g>
			</svg>

			<svg id="small-stars-reviews" xmlns="http://www.w3.org/2000/svg" width="16" height="16"
				viewBox="809 298.75 16 16.5">
				<path
					d="M824.986 305.09a.291.291 0 0 0-.232-.205l-5.18-.79-2.317-4.927A.285.285 0 0 0 817 299a.285.285 0 0 0-.257.168l-2.317 4.927-5.18.79a.291.291 0 0 0-.232.205.31.31 0 0 0 .072.307l3.75 3.836-.886 5.415a.308.308 0 0 0 .114.294.273.273 0 0 0 .302.023l4.634-2.557 4.634 2.557a.276.276 0 0 0 .302-.023.307.307 0 0 0 .113-.294l-.884-5.415 3.749-3.836c.078-.08.106-.2.072-.308Z"
					stroke-linejoin="round" stroke-linecap="round" stroke-width=".5" stroke="#ededed" fill="#ededed"
					fill-rule="evenodd"></path>
			</svg>

			<svg id="big-stars-reviews" xmlns="http://www.w3.org/2000/svg" width="25" height="24"
				viewBox="-0.75 -0.25 24 24">
				<path
					d="M24.61 10.25a.442.442 0 0 0-.356-.3l-7.976-1.159-3.567-7.227a.44.44 0 0 0-.79 0L8.354 8.792.378 9.95a.442.442 0 0 0-.245.752l5.772 5.625-1.363 7.945a.442.442 0 0 0 .64.464l7.134-3.75 7.134 3.75a.441.441 0 0 0 .64-.464l-1.363-7.944 5.772-5.626a.441.441 0 0 0 .111-.452Z"
					stroke-linejoin="round" stroke-linecap="round" stroke-width="1.5" stroke="#ededed" fill="#ededed"
					transform="matrix(.9391 0 0 .93609 -.25 -.484)"></path>
			</svg>
		</p>
	</div>
	<!-- data-product-id="62bc026e576e78.57608568" -->
	<!-- data-product-id="62bc030bf012f4.10202903" -->
	<!-- data-product-id="6237482" empty -->
	<div class="yotpo yotpo-main-widget" data-product-id="6237482" data-price="123" data-currency="USD"
		data-name="Product Title" data-url="localhost"
		data-image-url="https://www.rd.com/wp-content/uploads/2019/09/Cute-cat-lying-on-his-back-on-the-carpet.-Breed-British-mackerel-with-yellow-eyes-and-a-bushy-mustache.-Close-up-e1573490045672.jpg">
	</div>

	<div class="show-result-of-task">
		<button>Show result</button>
	</div>


	<script type="text/javascript">
		(function e() {
			var e = document.createElement("script");
			e.type = "text/javascript", e.async = true,
				e.src = "//staticw2.yotpo.com/sbXqrFWA5UEvdCPuIC6H3A1f69eEiPcs79otyiTA/widget.js";
			var t = document.getElementsByTagName("script")[0];
			t.parentNode.insertBefore(e, t)
		})();
	</script>

	<script type="text/javascript">
		//....... Observer method ...........
		const container = document.querySelector('.yotpo');
		const observer = new MutationObserver(() => {
			changeDom()
		});
		observer.observe(container, { childList: true });
		//........DOMNodeInserted method.......
		//document.querySelector('.yotpo.yotpo-main-widget').addEventListener('DOMNodeInserted', (event) => {
		//	changeDom();
		//}, { once: true })

		function formatDate(date) {
			const newData = date.split('/')
			const d = new Date().getFullYear().toString();
			const monthNames = [
				"Jan", "Feb", "Mar",
				"Apr", "May", "Jun", "Jul",
				"Aug", "Sept", "Oct",
				"Nov", "Dec"
			];
			const day = newData[1];
			const month = newData[0];
			const year = newData[2];

			return day + ' ' + monthNames[month - 1] + ' ' + d[0] + d[1] + year;
		}

		function changeDom() {
			const container = document.querySelector('.yotpo-reviews.yotpo-active');
			const observer = new MutationObserver(() => {
				changeReviewsBlock();
			});
			observer.observe(container, { childList: true });

			const mainBlock = document.querySelector('.yotpo.yotpo-main-widget').children[0];

			const blockReviews = mainBlock.querySelector('.yotpo-regular-box.yotpo-bottomline.yotpo-bottomline-2-boxes.yotpo-bottomline-empty-state');
			const yotoPager = mainBlock.querySelector('.yotpo-reviews.yotpo-active');

			const starsReviews = mainBlock.querySelector('.yotpo-bottomline-box-1.yotpo-stars-and-sum-reviews');
			starsReviews.insertAdjacentHTML('afterbegin',
				"<div id='average-raiting-count'>0.0</div>");
			starsReviews.insertAdjacentHTML('beforeend',
				"<div style='margin-top:10px;font-size:16px'>Average raiting</div>");
			mainBlock.querySelectorAll('div.write-review.yotpo-regular-box *[placeholder]').forEach(element => {
				element.setAttribute('placeholder', 'Type here');
				if (element.classList.contains('yotpo-text-box')) {
					element.style.height = '130px'
				};
			});

			const bigStarsReviews = document.querySelectorAll('span.stars-wrapper>.yotpo-icon.yotpo-icon-star');
			const smallStarsReviews = document.querySelectorAll('span.yotpo-icon.yotpo-icon-empty-star.rating-star.pull-left');
			bigStarsReviews.forEach(element => {
				const svgStar = document.querySelector('#big-stars-reviews');
				element.insertAdjacentElement('beforeend', svgStar.cloneNode(true))
			});

			blockReviews.insertAdjacentHTML('afterbegin',
				"<div id='total-reviews-block'><div id='total-reviews-number'>0</div><div id='total-reviews-text'>Total reviews</div></div>");

			if (!mainBlock.querySelector('.yotpo-nav-content .yotpo-review')) {
				smallStarsReviews.forEach(element => {
					const svgStar = document.querySelector('#small-stars-reviews');
					element.style.height = '16px';
					element.style.margin = '0 4px 5px 0'
					element.insertAdjacentElement('beforeend', svgStar.cloneNode(true));
				})
			} else {
				const averageRaiting = Array.from(starsReviews.querySelectorAll('.rating-star')).reduce((accum, star) => {
					if (star.classList.contains('yotpo-icon-star')) {
						accum += 1
					} else if (star.classList.contains('yotpo-icon-half-star')) {
						accum += 0.5
					}

					return accum
				}, 0);

				mainBlock.querySelector('#average-raiting-count').innerHTML = averageRaiting;
				mainBlock.querySelector('span.yotpo-sum-reviews').remove();
				const totalAverageCount = parseInt((mainBlock.querySelector('span.nav-tab-sum.yotpo-reviews-nav-tab-sum').innerHTML).match(/\d+/));
				mainBlock.querySelector('span.nav-tab-sum.yotpo-reviews-nav-tab-sum').remove();
				mainBlock.querySelector('div#total-reviews-number').innerHTML = totalAverageCount;

				changeReviewsBlock();

				function changeReviewsBlock() {
					mainBlock.querySelectorAll('.yotpo-nav-content .yotpo-header  span.yotpo-icon').forEach(star => {
						if (star.classList.contains('yotpo-icon-empty-star')) {
							const svgStar = document.querySelector('#small-stars-reviews');
							svgStar.children[0].setAttribute('fill', '#ededed')
							star.style.margin = '0 4px 5px 0';
							star.insertAdjacentElement('beforeend', svgStar.cloneNode(true));
						} else {
							const svgStar = document.querySelector('#small-stars-reviews');
							svgStar.children[0].setAttribute('fill', '#f2cd72')
							star.style.margin = '0 4px 5px 0'
							star.insertAdjacentElement('beforeend', svgStar.cloneNode(true));
						}
					});
					mainBlock.querySelectorAll('.yotpo-review-date').forEach(date => {
						date.innerHTML = formatDate(date.innerHTML)
					});
					mainBlock.querySelectorAll('span.yotpo-icon-profile').forEach(element => element.style.backgroundColor = '#77785e');
					mainBlock.querySelectorAll('span.yotpo-icon-share').forEach(element => {
						const svgShare = document.querySelector('#svg-share-icon');
						element.style.height = '16px';
						element.style.margin = '0 4px 5px 0';
						element.insertAdjacentElement('beforeend', svgShare.cloneNode(true));
					})
					mainBlock.querySelectorAll('span.yotpo-icon-thumbs-up').forEach(element => {
						const thumbup = document.querySelector('#thumbs-up-icon');
						element.insertAdjacentElement('beforeend', thumbup.cloneNode(true));
					})
					mainBlock.querySelectorAll('span.yotpo-icon-thumbs-down').forEach(element => {
						const thumbup = document.querySelector('#thumbs-up-icon');
						thumbup.style.transform = 'rotate(180deg)';
						element.insertAdjacentElement('beforeend', thumbup.cloneNode(true));
					})
				}
			}
		}

		const array = [
			{
				'text': 'Текст красного цвета',
				'cells': '1,2,3',
				'align': 'center',
				'valign': 'center',
				'color': 'FF0000',
				'bgcolor': '0000FF'
			},
			{
				'text': 'Текст зеленого цвета',
				'cells': '4,5,7,8',
				'align': 'center',
				'valign': 'center',
				'color': '00FF00',
				'bgcolor': 'FFFFFF'
			},
			{
				'text': 'Текст красного цвета',
				'cells': '9',
				'align': 'center',
				'valign': 'center',
				'color': 'FF0000',
				'bgcolor': '0000FF'
			},
		]

		const showResBtn = document.querySelector('div.show-result-of-task>button');
		showResBtn.parentNode.style.textAlign = 'center';
		showResBtn.parentNode.style.margin = '30px 0';
		const showResultBlock = document.querySelector('div.show-result-of-task');

		function generateTable(array) {
			//data is correct?
			let isIncorrectData = false;

			array.reduce((accum, { cells }) => {
				const cellNumbers = cells.split(',').sort((a, b) => a - b);

				const isAllEvenOrOdd = cellNumbers.every((value) => {
					return !!(value % 2);
				}) || cellNumbers.every((value) => {
					return !(value % 2);
				});
				//Проверка на повторяемость ячеек в разных обектах
				cellNumbers.forEach(number => {
					if ((accum.includes(number) || isAllEvenOrOdd)
						&& (cellNumbers.length > 1 || accum.length > 9) || number > 9 || number === '') {
						isIncorrectData = true;

						return;
					}
					accum.push(number);
				})
				if (isIncorrectData) {
					return accum;
				}
				switch (cellNumbers.length) {
					case 2:
						if (+cellNumbers[0] + 1 !== +cellNumbers[1]
							? (+cellNumbers[0] + 3 !== +cellNumbers[1])
							: (+cellNumbers[0] === 3 || +cellNumbers[0] === 6 || +cellNumbers[0] === 9)) {
							isIncorrectData = true;
						}

						break;
					case 3:
						if ([2, 3].includes(+cellNumbers[0])) { // is horizontal place correct?
							if (!(+cellNumbers[0] + 3 === +cellNumbers[1] && +cellNumbers[1] + 3 === +cellNumbers[2])) {
								isIncorrectData = true;
							}
						} else if ([4, 7].includes(+cellNumbers[0])) { // is vertical place correct?
							if (!(+cellNumbers[0] + 1 === +cellNumbers[1] && +cellNumbers[1] + 1 === +cellNumbers[2])) {
								isIncorrectData = true;
							}
						} else if (+cellNumbers[0] === 1) {
							if (!(+cellNumbers[0] + 3 === +cellNumbers[1]
								&& +cellNumbers[1] + 3 === +cellNumbers[2])
								&& !(+cellNumbers[0] + 1 === +cellNumbers[1] && +cellNumbers[1] + 1 === +cellNumbers[2])) {
								isIncorrectData = true;
							}
						} else {
							isIncorrectData = true;
						}

						break;
					case 4:
						if (!(+cellNumbers[0] + 4 === +cellNumbers.at(-1)
							&& +cellNumbers[1] + 2 === +cellNumbers[2]
							&& + cellNumbers[0] + +cellNumbers[1] !== +cellNumbers.at(-1))) {
							isIncorrectData = true;
						}

						break;
					case 5:
						isIncorrectData = true;
						break;
					case 6:
						if ([1, 4].includes(+cellNumbers[0])) { // is vertical place correct?
							if (!(+cellNumbers[0] + 1 === +cellNumbers[1]
								&& +cellNumbers[1] + 1 === +cellNumbers[2]
								&& +cellNumbers[2] + 1 === +cellNumbers[3]
								&& +cellNumbers[3] + 1 === +cellNumbers[4]
								&& +cellNumbers[4] + 1 === +cellNumbers[5])
								&& !(+cellNumbers[0] + 1 === +cellNumbers[1]
									&& +cellNumbers[2] + 1 === +cellNumbers[3]
									&& +cellNumbers[4] + 1 === +cellNumbers[5]
									&& +cellNumbers[0] + 7 === +cellNumbers.at(-1))) {
								isIncorrectData = true;
							}
						} else if (+cellNumbers[0] === 2) { // is horizontal place correct?
							if (!(+cellNumbers[0] + 1 === +cellNumbers[1]
								&& +cellNumbers[2] + 1 === +cellNumbers[3]
								&& +cellNumbers[4] + 1 === +cellNumbers[5]
								&& +cellNumbers[0] + 7 === +cellNumbers.at(-1))) {
								isIncorrectData = true;
							}
						} else {
							isIncorrectData = true;
						}

						break;
					case 7:
						isIncorrectData = true;
						break;
					case 8:
						isIncorrectData = true;
						break;
				}

				return accum;
			}, [])

			if (isIncorrectData) {
				const incorrectData = document.createElement('div');
				incorrectData.innerHTML = 'Data is incorrect'
				incorrectData.style.color = 'red';
				incorrectData.style.margin = '0 auto';
				incorrectData.classList.add('my-table')
				showResultBlock.appendChild(incorrectData);
			} else {
				const sortedArray = array.sort((current, next) => +current.cells[0] - +next.cells[0]);
				const myTable = document.createElement('table');
				myTable.classList.add('my-table');
				myTable.setAttribute('width', '300px');
				myTable.setAttribute('height', '300px');

				myTable.style.borderCollapse = 'collapse';
				myTable.style.margin = '30px auto';


				const tBody = document.createElement('tbody');
				myTable.appendChild(tBody);

				const countOfRow = 3;
				const countOfColumn = 3;

				let counter = 0;
				// Create table
				for (let i = 0; i < countOfRow; i++) {
					const tr = document.createElement('tr');

					for (let j = 0; j < countOfColumn; j++) {
						counter++;
						const td = document.createElement('td');
						td.style.border = '1px solid black';
						td.setAttribute('id', `cell${counter}`);
						td.textContent = counter;
						td.style.width = '100px';
						td.style.height = '100px';
						tr.appendChild(td);
					}
					tBody.appendChild(tr);
				}
				// Apply rules
				sortedArray.forEach(currentRules => {
					const currentCells = currentRules.cells.split(',').sort((a, b) => a - b);
					const isVertical = (+currentCells.length === 6 && +currentCells[0] + 2 !== +currentCells[2]);

					currentCells.forEach((cell, index) => {
						const { text, align, valign, color, bgcolor } = currentRules;

						if (currentCells.length === 4 || currentCells.length === 9) { //SQUARE
							const foundCell = myTable.querySelector(`#cell${currentCells[0]}`);

							for (let i = 1; i < currentCells.length; i++) {
								myTable.querySelector(`#cell${currentCells.at(-i)}`)
									&& myTable.querySelector(`#cell${currentCells.at(-i)}`).remove();
							}
							foundCell.setAttribute('colspan', +currentCells.length / 2);
							foundCell.setAttribute('rowspan', +currentCells.length / 2);
							foundCell.setAttribute('align', align);
							foundCell.setAttribute('valign', valign);
							foundCell.setAttribute('bgcolor', bgcolor);
							foundCell.style.color = '#' + color;
							foundCell.textContent = text;
						} else if (+cell + 1 === +currentCells[index + 1] && !isVertical) { // RECTANGLE HORIZONTAL
							if (currentCells.length === countOfRow) {
								const foundCell = myTable.querySelector(`#cell${currentCells[0]}`);
								foundCell.setAttribute('colspan', currentCells.length);

								for (let i = 1; i < currentCells.length; i++) {
									myTable.querySelector(`#cell${currentCells.at(-i)}`)
										&& myTable.querySelector(`#cell${currentCells.at(-i)}`).remove();
								}

								foundCell.setAttribute('align', align);
								foundCell.setAttribute('valign', valign);
								foundCell.setAttribute('bgcolor', bgcolor);
								foundCell.style.color = '#' + color;
								foundCell.textContent = text;
							} else if (+currentCells.length === countOfRow * 2 || +currentCells.length === countOfRow * 3
								&& +cell + 1 !== +currentCells[index + 1]) {

								const foundCell = myTable.querySelector(`#cell${currentCells[0]}`);
								foundCell.setAttribute('colspan', currentCells.length / 2);
								foundCell.setAttribute('rowspan', currentCells.length / countOfRow);

								for (let i = 1; i < currentCells.length; i++) {
									myTable.querySelector(`#cell${currentCells.at(-i)}`)
										&& myTable.querySelector(`#cell${currentCells.at(-i)}`).remove();
								}

								foundCell.setAttribute('align', align);
								foundCell.setAttribute('valign', valign);
								foundCell.setAttribute('bgcolor', bgcolor);
								foundCell.style.color = '#' + color;
								foundCell.textContent = text;
							} else {
								const foundCell = myTable.querySelector(`#cell${cell}`);
								foundCell.setAttribute('colspan', currentCells.length);
								foundCell.setAttribute('align', align);
								foundCell.setAttribute('valign', valign);
								foundCell.setAttribute('bgcolor', bgcolor);
								foundCell.style.color = '#' + color;
								foundCell.textContent = text;
								myTable.querySelector(`#cell${currentCells.at(-1)}`).remove();
							}

						} else if (+cell + countOfRow === +currentCells[index + 1] || isVertical) { // RECTANGLE VERTICAL
							if (currentCells.length === countOfRow) {
								const foundCell = myTable.querySelector(`#cell${currentCells[0]}`);
								foundCell.setAttribute('rowspan', currentCells.length);

								for (let i = 1; i < currentCells.length; i++) {
									myTable.querySelector(`#cell${currentCells.at(-i)}`)
										&& myTable.querySelector(`#cell${currentCells.at(-i)}`).remove();
								}

								foundCell.setAttribute('align', align);
								foundCell.setAttribute('valign', valign);
								foundCell.setAttribute('bgcolor', bgcolor);
								foundCell.style.color = '#' + color;
								foundCell.textContent = text;
							} else if (+currentCells.length === countOfRow * 2) {
								const foundCell = myTable.querySelector(`#cell${currentCells[0]}`);

								foundCell.setAttribute('rowspan', currentCells.length / 2);
								foundCell.setAttribute('colspan', currentCells.length / countOfRow);

								for (let i = 1; i < currentCells.length; i++) {
									myTable.querySelector(`#cell${currentCells.at(-i)}`)
										&& myTable.querySelector(`#cell${currentCells.at(-i)}`).remove();
								}

								foundCell.setAttribute('align', align);
								foundCell.setAttribute('valign', valign);
								foundCell.setAttribute('bgcolor', bgcolor);
								foundCell.style.color = '#' + color;
								foundCell.textContent = text;
							} else {
								const foundCell = myTable.querySelector(`#cell${cell}`);

								foundCell.setAttribute('rowspan', currentCells.length);
								foundCell.setAttribute('align', align);
								foundCell.setAttribute('valign', valign);
								foundCell.setAttribute('bgcolor', bgcolor);
								foundCell.style.color = '#' + color;
								foundCell.textContent = text;
								myTable.querySelector(`#cell${currentCells.at(-1)}`).remove();
							}
						}
						if (currentCells.length === 1) {
							const foundCell = myTable.querySelector(`#cell${cell}`);

							foundCell.setAttribute('align', align);
							foundCell.setAttribute('valign', valign);
							foundCell.setAttribute('bgcolor', bgcolor);
							foundCell.style.color = '#' + color;
							foundCell.textContent = text;
						}
					})
				})

				showResultBlock.appendChild(myTable);
			}
		}

		showResBtn.addEventListener('click', () => {
		if (document.querySelector('.my-table')) {
			document.querySelector('.show-result-of-task>button').textContent = 'Show result';
			document.querySelector('.my-table').remove()
		} else {
			generateTable(array)
			document.querySelector('.show-result-of-task>button').textContent = 'Hide Result';
		}
		})
	</script>
</body>

</html>